$scope.authStuff = function() {
    firebase.auth().onAuthStateChanged(function(user) {
        if (user) {
            // User is signed in.
            $("#logout").attr("title", user.email);
            //$scope.loadUser(user);
            // $location.path('/home').replace();
            $scope.user = user;
            localStorage.setItem("user", user.email);
            // $location.path('/home'); .reload(false)

            // ...
        } else {
            // User is signed out.
            // $scope.loadUser(false);
            $scope.$apply(function() {
                localStorage.removeItem("user");
                $scope.userData = false;
                console.log("REESET");
                $location.path('/login');
                $scope.user = null;
                $scope.loggedIn = false;
            });

            console.log("SIGNED OUT");
            // ...
        }
    });
};
$scope.login = function() {
    $("#login-error").text("");
    firebase.auth().setPersistence(firebase.auth.Auth.Persistence.SESSION).then(function() {
        // Existing and future Auth states are now persisted in the current
        // session only. Closing the window would clear any existing state even
        // if a user forgets to sign out.
        // ...
        // New sign-in will be persisted with session persistence.
        firebase.auth().signInWithEmailAndPassword($("#login-email").val(), $("#login-password").val()).then(function(aaa) {
            console.log("YAY", aaa);
            localStorage.setItem("user", aaa.email);
            $scope.loadUser(aaa.email);
            // $location.path('/home');
        }).catch(function(error) {
            console.log("errror", error.message);
        });
    }).catch(function(error) {
        // Handle Errors here.
        // let errorCode = error.code;
        // let errorMessage = error.message;
        $("#login-error").text(error.message);
        console.log("errror", error.message);
    });
};
$scope.resetPass = function() {
    firebase.auth().sendPasswordResetEmail($("#login-email").val());
};
$scope.signup = function() {
    $("#signup-error").text("");

    firebase.auth().createUserWithEmailAndPassword($("#signup-email").val(), $("#signup-password").val()).catch(function(error) {
        // Handle Errors here.
        $("#signup-error").text(error.message);

        let errorCode = error.code;
        let errorMessage = error.message;
        // ...
    });
};
$scope.logout = function() {
    firebase.auth().signOut().then(function() {
        localStorage.removeItem("user");
        $location.path('/login');
    }, function(error) {
        // An error happened.
    });
};
$scope.addItem = function(item) {
    db.collection("items").add(item).then(function(doc) {
        console.log(doc, "added!");
    }).catch(function(error) {
        console.error("Error adding document: ", error);
    });
}
/*
            //.where("user", "==", user)
            db.collection("testitems").get().then(function(querySnapshot) {
                    if (querySnapshot.docs.length) {
                        querySnapshot.forEach(function(doc) {
                            let data = doc.data();
                            console.log("DATATAA", data);
                            $scope.$apply(function() {
                                localStorage.setItem("docId", doc.id);
                                if (typeof data.exercises === "undefined") {
                                    data.exercises = $scope.exercises;
                                    db.collection("projects").doc(localStorage.getItem("docId")).set(
                                        data
                                    ).then(function() {
                                        console.log("EXERCISES ADDED!!!");
                                    }).catch(function(err) {
                                        console.error(err);
                                    });
                                }
                                $scope.userData = data;
                                $scope.loggedIn = true;
                                let total = 0;
                                $scope.userData.exercises.forEach(function(entV, innn) {
                                    if (entV.passed) {
                                        total += 1;
                                    }
                                });
                                $scope.completedExercises = total;

                                if (segment) {
                                    if (segment[0] === "login") {
                                        // $location.path("/home");
                                    } else if (segment[0] == "project") {
                                        $scope.loadProject(segment[1]);
                                    } else if (segment[0] == "exercise") {
                                        $scope.openExercise(segment[1]);
                                    }
                                } else {
                                    $location.path("/home");
                                }

                                // ALWAYS REMOVE LOADING
                                $timeout(function() {
                                    $scope.loading = false;
                                }, 700);

                            });
                        });
                    } else {
                        let userData = {
                            user: user,
                            projects: []
                        };
                        db.collection("projects").add(userData)
                            .then(function(doc) {
                                $scope.$apply(function() {
                                    localStorage.setItem("docId", doc.id);
                                    $scope.userData = userData;
                                    $scope.loggedIn = true;
                                });
                            })
                            .catch(function(error) {
                                console.error("Error adding document: ", error);
                            });
                    }
                })
                .catch(function(error) {
                    console.log("Error getting documents: ", error);
                });
                */
